

# This file was autogenerated by some hot garbage in the `uniffi` crate.
# Trust me, you don't want to mess with it!

# Common helper code.
#
# Ideally this would live in a separate .py file where it can be unittested etc
# in isolation, and perhaps even published as a re-useable package.
#
# However, it's important that the details of how this helper code works (e.g. the
# way that different builtin types are passed across the FFI) exactly match what's
# expected by the rust code on the other side of the interface. In practice right
# now that means coming from the exact some version of `uniffi` that was used to
# compile the rust component. The easiest way to ensure this is to bundle the Python
# helpers directly inline like we're doing here.

import os
import sys
import ctypes
import enum
import struct
import contextlib
import datetime
import typing
import asyncio
import platform

# Used for default argument values
_DEFAULT = object()


class _UniffiRustBuffer(ctypes.Structure):
    _fields_ = [
        ("capacity", ctypes.c_int32),
        ("len", ctypes.c_int32),
        ("data", ctypes.POINTER(ctypes.c_char)),
    ]

    @staticmethod
    def alloc(size):
        return _rust_call(_UniffiLib.ffi_hyperbee_rustbuffer_alloc, size)

    @staticmethod
    def reserve(rbuf, additional):
        return _rust_call(_UniffiLib.ffi_hyperbee_rustbuffer_reserve, rbuf, additional)

    def free(self):
        return _rust_call(_UniffiLib.ffi_hyperbee_rustbuffer_free, self)

    def __str__(self):
        return "_UniffiRustBuffer(capacity={}, len={}, data={})".format(
            self.capacity,
            self.len,
            self.data[0:self.len]
        )

    @contextlib.contextmanager
    def alloc_with_builder(*args):
        """Context-manger to allocate a buffer using a _UniffiRustBufferBuilder.

        The allocated buffer will be automatically freed if an error occurs, ensuring that
        we don't accidentally leak it.
        """
        builder = _UniffiRustBufferBuilder()
        try:
            yield builder
        except:
            builder.discard()
            raise

    @contextlib.contextmanager
    def consume_with_stream(self):
        """Context-manager to consume a buffer using a _UniffiRustBufferStream.

        The _UniffiRustBuffer will be freed once the context-manager exits, ensuring that we don't
        leak it even if an error occurs.
        """
        try:
            s = _UniffiRustBufferStream.from_rust_buffer(self)
            yield s
            if s.remaining() != 0:
                raise RuntimeError("junk data left in buffer at end of consume_with_stream")
        finally:
            self.free()

    @contextlib.contextmanager
    def read_with_stream(self):
        """Context-manager to read a buffer using a _UniffiRustBufferStream.

        This is like consume_with_stream, but doesn't free the buffer afterwards.
        It should only be used with borrowed `_UniffiRustBuffer` data.
        """
        s = _UniffiRustBufferStream.from_rust_buffer(self)
        yield s
        if s.remaining() != 0:
            raise RuntimeError("junk data left in buffer at end of read_with_stream")

class _UniffiForeignBytes(ctypes.Structure):
    _fields_ = [
        ("len", ctypes.c_int32),
        ("data", ctypes.POINTER(ctypes.c_char)),
    ]

    def __str__(self):
        return "_UniffiForeignBytes(len={}, data={})".format(self.len, self.data[0:self.len])


class _UniffiRustBufferStream:
    """
    Helper for structured reading of bytes from a _UniffiRustBuffer
    """

    def __init__(self, data, len):
        self.data = data
        self.len = len
        self.offset = 0

    @classmethod
    def from_rust_buffer(cls, buf):
        return cls(buf.data, buf.len)

    def remaining(self):
        return self.len - self.offset

    def _unpack_from(self, size, format):
        if self.offset + size > self.len:
            raise InternalError("read past end of rust buffer")
        value = struct.unpack(format, self.data[self.offset:self.offset+size])[0]
        self.offset += size
        return value

    def read(self, size):
        if self.offset + size > self.len:
            raise InternalError("read past end of rust buffer")
        data = self.data[self.offset:self.offset+size]
        self.offset += size
        return data

    def read_i8(self):
        return self._unpack_from(1, ">b")

    def read_u8(self):
        return self._unpack_from(1, ">B")

    def read_i16(self):
        return self._unpack_from(2, ">h")

    def read_u16(self):
        return self._unpack_from(2, ">H")

    def read_i32(self):
        return self._unpack_from(4, ">i")

    def read_u32(self):
        return self._unpack_from(4, ">I")

    def read_i64(self):
        return self._unpack_from(8, ">q")

    def read_u64(self):
        return self._unpack_from(8, ">Q")

    def read_float(self):
        v = self._unpack_from(4, ">f")
        return v

    def read_double(self):
        return self._unpack_from(8, ">d")

    def read_c_size_t(self):
        return self._unpack_from(ctypes.sizeof(ctypes.c_size_t) , "@N")

class _UniffiRustBufferBuilder:
    """
    Helper for structured writing of bytes into a _UniffiRustBuffer.
    """

    def __init__(self):
        self.rbuf = _UniffiRustBuffer.alloc(16)
        self.rbuf.len = 0

    def finalize(self):
        rbuf = self.rbuf
        self.rbuf = None
        return rbuf

    def discard(self):
        if self.rbuf is not None:
            rbuf = self.finalize()
            rbuf.free()

    @contextlib.contextmanager
    def _reserve(self, num_bytes):
        if self.rbuf.len + num_bytes > self.rbuf.capacity:
            self.rbuf = _UniffiRustBuffer.reserve(self.rbuf, num_bytes)
        yield None
        self.rbuf.len += num_bytes

    def _pack_into(self, size, format, value):
        with self._reserve(size):
            # XXX TODO: I feel like I should be able to use `struct.pack_into` here but can't figure it out.
            for i, byte in enumerate(struct.pack(format, value)):
                self.rbuf.data[self.rbuf.len + i] = byte

    def write(self, value):
        with self._reserve(len(value)):
            for i, byte in enumerate(value):
                self.rbuf.data[self.rbuf.len + i] = byte

    def write_i8(self, v):
        self._pack_into(1, ">b", v)

    def write_u8(self, v):
        self._pack_into(1, ">B", v)

    def write_i16(self, v):
        self._pack_into(2, ">h", v)

    def write_u16(self, v):
        self._pack_into(2, ">H", v)

    def write_i32(self, v):
        self._pack_into(4, ">i", v)

    def write_u32(self, v):
        self._pack_into(4, ">I", v)

    def write_i64(self, v):
        self._pack_into(8, ">q", v)

    def write_u64(self, v):
        self._pack_into(8, ">Q", v)

    def write_float(self, v):
        self._pack_into(4, ">f", v)

    def write_double(self, v):
        self._pack_into(8, ">d", v)

    def write_c_size_t(self, v):
        self._pack_into(ctypes.sizeof(ctypes.c_size_t) , "@N", v)
# A handful of classes and functions to support the generated data structures.
# This would be a good candidate for isolating in its own ffi-support lib.

class InternalError(Exception):
    pass

class _UniffiRustCallStatus(ctypes.Structure):
    """
    Error runtime.
    """
    _fields_ = [
        ("code", ctypes.c_int8),
        ("error_buf", _UniffiRustBuffer),
    ]

    # These match the values from the uniffi::rustcalls module
    CALL_SUCCESS = 0
    CALL_ERROR = 1
    CALL_PANIC = 2

    def __str__(self):
        if self.code == _UniffiRustCallStatus.CALL_SUCCESS:
            return "_UniffiRustCallStatus(CALL_SUCCESS)"
        elif self.code == _UniffiRustCallStatus.CALL_ERROR:
            return "_UniffiRustCallStatus(CALL_ERROR)"
        elif self.code == _UniffiRustCallStatus.CALL_PANIC:
            return "_UniffiRustCallStatus(CALL_PANIC)"
        else:
            return "_UniffiRustCallStatus(<invalid code>)"

def _rust_call(fn, *args):
    # Call a rust function
    return _rust_call_with_error(None, fn, *args)

def _rust_call_with_error(error_ffi_converter, fn, *args):
    # Call a rust function and handle any errors
    #
    # This function is used for rust calls that return Result<> and therefore can set the CALL_ERROR status code.
    # error_ffi_converter must be set to the _UniffiConverter for the error class that corresponds to the result.
    call_status = _UniffiRustCallStatus(code=_UniffiRustCallStatus.CALL_SUCCESS, error_buf=_UniffiRustBuffer(0, 0, None))

    args_with_error = args + (ctypes.byref(call_status),)
    result = fn(*args_with_error)
    _uniffi_check_call_status(error_ffi_converter, call_status)
    return result

def _uniffi_check_call_status(error_ffi_converter, call_status):
    if call_status.code == _UniffiRustCallStatus.CALL_SUCCESS:
        pass
    elif call_status.code == _UniffiRustCallStatus.CALL_ERROR:
        if error_ffi_converter is None:
            call_status.error_buf.free()
            raise InternalError("_rust_call_with_error: CALL_ERROR, but error_ffi_converter is None")
        else:
            raise error_ffi_converter.lift(call_status.error_buf)
    elif call_status.code == _UniffiRustCallStatus.CALL_PANIC:
        # When the rust code sees a panic, it tries to construct a _UniffiRustBuffer
        # with the message.  But if that code panics, then it just sends back
        # an empty buffer.
        if call_status.error_buf.len > 0:
            msg = _UniffiConverterString.lift(call_status.error_buf)
        else:
            msg = "Unknown rust panic"
        raise InternalError(msg)
    else:
        raise InternalError("Invalid _UniffiRustCallStatus code: {}".format(
            call_status.code))

# A function pointer for a callback as defined by UniFFI.
# Rust definition `fn(handle: u64, method: u32, args: _UniffiRustBuffer, buf_ptr: *mut _UniffiRustBuffer) -> int`
_UNIFFI_FOREIGN_CALLBACK_T = ctypes.CFUNCTYPE(ctypes.c_int, ctypes.c_ulonglong, ctypes.c_ulong, ctypes.POINTER(ctypes.c_char), ctypes.c_int, ctypes.POINTER(_UniffiRustBuffer))

# UniFFI future continuation
_UNIFFI_FUTURE_CONTINUATION_T = ctypes.CFUNCTYPE(None, ctypes.c_size_t, ctypes.c_int8)

class _UniffiPointerManagerCPython:
    """
    Manage giving out pointers to Python objects on CPython

    This class is used to generate opaque pointers that reference Python objects to pass to Rust.
    It assumes a CPython platform.  See _UniffiPointerManagerGeneral for the alternative.
    """

    def new_pointer(self, obj):
        """
        Get a pointer for an object as a ctypes.c_size_t instance

        Each call to new_pointer() must be balanced with exactly one call to release_pointer()

        This returns a ctypes.c_size_t.  This is always the same size as a pointer and can be
        interchanged with pointers for FFI function arguments and return values.
        """
        # IncRef the object since we're going to pass a pointer to Rust
        ctypes.pythonapi.Py_IncRef(ctypes.py_object(obj))
        # id() is the object address on CPython
        # (https://docs.python.org/3/library/functions.html#id)
        return id(obj)

    def release_pointer(self, address):
        py_obj = ctypes.cast(address, ctypes.py_object)
        obj = py_obj.value
        ctypes.pythonapi.Py_DecRef(py_obj)
        return obj

    def lookup(self, address):
        return ctypes.cast(address, ctypes.py_object).value

class _UniffiPointerManagerGeneral:
    """
    Manage giving out pointers to Python objects on non-CPython platforms

    This has the same API as _UniffiPointerManagerCPython, but doesn't assume we're running on
    CPython and is slightly slower.

    Instead of using real pointers, it maps integer values to objects and returns the keys as
    c_size_t values.
    """

    def __init__(self):
        self._map = {}
        self._lock = threading.Lock()
        self._current_handle = 0

    def new_pointer(self, obj):
        with self._lock:
            handle = self._current_handle
            self._current_handle += 1
            self._map[handle] = obj
        return handle

    def release_pointer(self, handle):
        with self._lock:
            return self._map.pop(handle)

    def lookup(self, handle):
        with self._lock:
            return self._map[handle]

# Pick an pointer manager implementation based on the platform
if platform.python_implementation() == 'CPython':
    _UniffiPointerManager = _UniffiPointerManagerCPython # type: ignore
else:
    _UniffiPointerManager = _UniffiPointerManagerGeneral # type: ignore
# Types conforming to `_UniffiConverterPrimitive` pass themselves directly over the FFI.
class _UniffiConverterPrimitive:
    @classmethod
    def lift(cls, value):
        return value
 
    @classmethod
    def lower(cls, value):
        return value

class _UniffiConverterPrimitiveInt(_UniffiConverterPrimitive):
    @classmethod
    def check_lower(cls, value):
        try:
            value = value.__index__()
        except Exception:
            raise TypeError("'{}' object cannot be interpreted as an integer".format(type(value).__name__))
        if not isinstance(value, int):
            raise TypeError("__index__ returned non-int (type {})".format(type(value).__name__))
        if not cls.VALUE_MIN <= value < cls.VALUE_MAX:
            raise ValueError("{} requires {} <= value < {}".format(cls.CLASS_NAME, cls.VALUE_MIN, cls.VALUE_MAX))

class _UniffiConverterPrimitiveFloat(_UniffiConverterPrimitive):
    @classmethod
    def check_lower(cls, value):
        try:
            value = value.__float__()
        except Exception:
            raise TypeError("must be real number, not {}".format(type(value).__name__))
        if not isinstance(value, float):
            raise TypeError("__float__ returned non-float (type {})".format(type(value).__name__))

# Helper class for wrapper types that will always go through a _UniffiRustBuffer.
# Classes should inherit from this and implement the `read` and `write` static methods.
class _UniffiConverterRustBuffer:
    @classmethod
    def lift(cls, rbuf):
        with rbuf.consume_with_stream() as stream:
            return cls.read(stream)

    @classmethod
    def lower(cls, value):
        with _UniffiRustBuffer.alloc_with_builder() as builder:
            cls.write(value, builder)
            return builder.finalize()

# Contains loading, initialization code, and the FFI Function declarations.
# Define some ctypes FFI types that we use in the library

"""
Function pointer for a Rust task, which a callback function that takes a opaque pointer
"""
_UNIFFI_RUST_TASK = ctypes.CFUNCTYPE(None, ctypes.c_void_p, ctypes.c_int8)

def _uniffi_future_callback_t(return_type):
    """
    Factory function to create callback function types for async functions
    """
    return ctypes.CFUNCTYPE(None, ctypes.c_size_t, return_type, _UniffiRustCallStatus)

def _uniffi_load_indirect():
    """
    This is how we find and load the dynamic library provided by the component.
    For now we just look it up by name.
    """
    if sys.platform == "darwin":
        libname = "lib{}.dylib"
    elif sys.platform.startswith("win"):
        # As of python3.8, ctypes does not seem to search $PATH when loading DLLs.
        # We could use `os.add_dll_directory` to configure the search path, but
        # it doesn't feel right to mess with application-wide settings. Let's
        # assume that the `.dll` is next to the `.py` file and load by full path.
        libname = os.path.join(
            os.path.dirname(__file__),
            "{}.dll",
        )
    else:
        # Anything else must be an ELF platform - Linux, *BSD, Solaris/illumos
        libname = "lib{}.so"

    libname = libname.format("hyperbee")
    path = os.path.join(os.path.dirname(__file__), libname)
    lib = ctypes.cdll.LoadLibrary(path)
    return lib

def _uniffi_check_contract_api_version(lib):
    # Get the bindings contract version from our ComponentInterface
    bindings_contract_version = 25
    # Get the scaffolding contract version by calling the into the dylib
    scaffolding_contract_version = lib.ffi_hyperbee_uniffi_contract_version()
    if bindings_contract_version != scaffolding_contract_version:
        raise InternalError("UniFFI contract version mismatch: try cleaning and rebuilding your project")

def _uniffi_check_api_checksums(lib):
    if lib.uniffi_hyperbee_checksum_func_default_sub_config() != 8666:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_hyperbee_checksum_func_hyperbee_from_ram() != 27103:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_hyperbee_checksum_func_hyperbee_from_storage_dir() != 20591:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_hyperbee_checksum_method_hyperbee_delete() != 928:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_hyperbee_checksum_method_hyperbee_get() != 44784:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_hyperbee_checksum_method_hyperbee_put() != 29295:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_hyperbee_checksum_method_hyperbee_sub() != 46437:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_hyperbee_checksum_method_hyperbee_version() != 17462:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_hyperbee_checksum_method_prefixed_delete() != 1786:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_hyperbee_checksum_method_prefixed_get() != 16095:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")
    if lib.uniffi_hyperbee_checksum_method_prefixed_put() != 32447:
        raise InternalError("UniFFI API checksum mismatch: try cleaning and rebuilding your project")

# A ctypes library to expose the extern-C FFI definitions.
# This is an implementation detail which will be called internally by the public API.

_UniffiLib = _uniffi_load_indirect()
_UniffiLib.uniffi_hyperbee_fn_clone_hyperbee.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_hyperbee_fn_clone_hyperbee.restype = ctypes.c_void_p
_UniffiLib.uniffi_hyperbee_fn_free_hyperbee.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_hyperbee_fn_free_hyperbee.restype = None
_UniffiLib.uniffi_hyperbee_fn_method_hyperbee_delete.argtypes = (
    ctypes.c_void_p,
    _UniffiRustBuffer,
)
_UniffiLib.uniffi_hyperbee_fn_method_hyperbee_delete.restype = ctypes.c_void_p
_UniffiLib.uniffi_hyperbee_fn_method_hyperbee_get.argtypes = (
    ctypes.c_void_p,
    _UniffiRustBuffer,
)
_UniffiLib.uniffi_hyperbee_fn_method_hyperbee_get.restype = ctypes.c_void_p
_UniffiLib.uniffi_hyperbee_fn_method_hyperbee_put.argtypes = (
    ctypes.c_void_p,
    _UniffiRustBuffer,
    _UniffiRustBuffer,
)
_UniffiLib.uniffi_hyperbee_fn_method_hyperbee_put.restype = ctypes.c_void_p
_UniffiLib.uniffi_hyperbee_fn_method_hyperbee_sub.argtypes = (
    ctypes.c_void_p,
    _UniffiRustBuffer,
    _UniffiRustBuffer,
)
_UniffiLib.uniffi_hyperbee_fn_method_hyperbee_sub.restype = ctypes.c_void_p
_UniffiLib.uniffi_hyperbee_fn_method_hyperbee_version.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.uniffi_hyperbee_fn_method_hyperbee_version.restype = ctypes.c_void_p
_UniffiLib.uniffi_hyperbee_fn_clone_prefixed.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_hyperbee_fn_clone_prefixed.restype = ctypes.c_void_p
_UniffiLib.uniffi_hyperbee_fn_free_prefixed.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_hyperbee_fn_free_prefixed.restype = None
_UniffiLib.uniffi_hyperbee_fn_method_prefixed_delete.argtypes = (
    ctypes.c_void_p,
    _UniffiRustBuffer,
)
_UniffiLib.uniffi_hyperbee_fn_method_prefixed_delete.restype = ctypes.c_void_p
_UniffiLib.uniffi_hyperbee_fn_method_prefixed_get.argtypes = (
    ctypes.c_void_p,
    _UniffiRustBuffer,
)
_UniffiLib.uniffi_hyperbee_fn_method_prefixed_get.restype = ctypes.c_void_p
_UniffiLib.uniffi_hyperbee_fn_method_prefixed_put.argtypes = (
    ctypes.c_void_p,
    _UniffiRustBuffer,
    _UniffiRustBuffer,
)
_UniffiLib.uniffi_hyperbee_fn_method_prefixed_put.restype = ctypes.c_void_p
_UniffiLib.uniffi_hyperbee_fn_func_default_sub_config.argtypes = (
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.uniffi_hyperbee_fn_func_default_sub_config.restype = _UniffiRustBuffer
_UniffiLib.uniffi_hyperbee_fn_func_hyperbee_from_ram.argtypes = (
)
_UniffiLib.uniffi_hyperbee_fn_func_hyperbee_from_ram.restype = ctypes.c_void_p
_UniffiLib.uniffi_hyperbee_fn_func_hyperbee_from_storage_dir.argtypes = (
    _UniffiRustBuffer,
)
_UniffiLib.uniffi_hyperbee_fn_func_hyperbee_from_storage_dir.restype = ctypes.c_void_p
_UniffiLib.ffi_hyperbee_rustbuffer_alloc.argtypes = (
    ctypes.c_int32,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_hyperbee_rustbuffer_alloc.restype = _UniffiRustBuffer
_UniffiLib.ffi_hyperbee_rustbuffer_from_bytes.argtypes = (
    _UniffiForeignBytes,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_hyperbee_rustbuffer_from_bytes.restype = _UniffiRustBuffer
_UniffiLib.ffi_hyperbee_rustbuffer_free.argtypes = (
    _UniffiRustBuffer,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_hyperbee_rustbuffer_free.restype = None
_UniffiLib.ffi_hyperbee_rustbuffer_reserve.argtypes = (
    _UniffiRustBuffer,
    ctypes.c_int32,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_hyperbee_rustbuffer_reserve.restype = _UniffiRustBuffer
_UniffiLib.ffi_hyperbee_rust_future_poll_u8.argtypes = (
    ctypes.c_void_p,
    _UNIFFI_FUTURE_CONTINUATION_T,
    ctypes.c_size_t,
)
_UniffiLib.ffi_hyperbee_rust_future_poll_u8.restype = None
_UniffiLib.ffi_hyperbee_rust_future_cancel_u8.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_hyperbee_rust_future_cancel_u8.restype = None
_UniffiLib.ffi_hyperbee_rust_future_free_u8.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_hyperbee_rust_future_free_u8.restype = None
_UniffiLib.ffi_hyperbee_rust_future_complete_u8.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_hyperbee_rust_future_complete_u8.restype = ctypes.c_uint8
_UniffiLib.ffi_hyperbee_rust_future_poll_i8.argtypes = (
    ctypes.c_void_p,
    _UNIFFI_FUTURE_CONTINUATION_T,
    ctypes.c_size_t,
)
_UniffiLib.ffi_hyperbee_rust_future_poll_i8.restype = None
_UniffiLib.ffi_hyperbee_rust_future_cancel_i8.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_hyperbee_rust_future_cancel_i8.restype = None
_UniffiLib.ffi_hyperbee_rust_future_free_i8.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_hyperbee_rust_future_free_i8.restype = None
_UniffiLib.ffi_hyperbee_rust_future_complete_i8.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_hyperbee_rust_future_complete_i8.restype = ctypes.c_int8
_UniffiLib.ffi_hyperbee_rust_future_poll_u16.argtypes = (
    ctypes.c_void_p,
    _UNIFFI_FUTURE_CONTINUATION_T,
    ctypes.c_size_t,
)
_UniffiLib.ffi_hyperbee_rust_future_poll_u16.restype = None
_UniffiLib.ffi_hyperbee_rust_future_cancel_u16.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_hyperbee_rust_future_cancel_u16.restype = None
_UniffiLib.ffi_hyperbee_rust_future_free_u16.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_hyperbee_rust_future_free_u16.restype = None
_UniffiLib.ffi_hyperbee_rust_future_complete_u16.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_hyperbee_rust_future_complete_u16.restype = ctypes.c_uint16
_UniffiLib.ffi_hyperbee_rust_future_poll_i16.argtypes = (
    ctypes.c_void_p,
    _UNIFFI_FUTURE_CONTINUATION_T,
    ctypes.c_size_t,
)
_UniffiLib.ffi_hyperbee_rust_future_poll_i16.restype = None
_UniffiLib.ffi_hyperbee_rust_future_cancel_i16.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_hyperbee_rust_future_cancel_i16.restype = None
_UniffiLib.ffi_hyperbee_rust_future_free_i16.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_hyperbee_rust_future_free_i16.restype = None
_UniffiLib.ffi_hyperbee_rust_future_complete_i16.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_hyperbee_rust_future_complete_i16.restype = ctypes.c_int16
_UniffiLib.ffi_hyperbee_rust_future_poll_u32.argtypes = (
    ctypes.c_void_p,
    _UNIFFI_FUTURE_CONTINUATION_T,
    ctypes.c_size_t,
)
_UniffiLib.ffi_hyperbee_rust_future_poll_u32.restype = None
_UniffiLib.ffi_hyperbee_rust_future_cancel_u32.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_hyperbee_rust_future_cancel_u32.restype = None
_UniffiLib.ffi_hyperbee_rust_future_free_u32.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_hyperbee_rust_future_free_u32.restype = None
_UniffiLib.ffi_hyperbee_rust_future_complete_u32.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_hyperbee_rust_future_complete_u32.restype = ctypes.c_uint32
_UniffiLib.ffi_hyperbee_rust_future_poll_i32.argtypes = (
    ctypes.c_void_p,
    _UNIFFI_FUTURE_CONTINUATION_T,
    ctypes.c_size_t,
)
_UniffiLib.ffi_hyperbee_rust_future_poll_i32.restype = None
_UniffiLib.ffi_hyperbee_rust_future_cancel_i32.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_hyperbee_rust_future_cancel_i32.restype = None
_UniffiLib.ffi_hyperbee_rust_future_free_i32.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_hyperbee_rust_future_free_i32.restype = None
_UniffiLib.ffi_hyperbee_rust_future_complete_i32.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_hyperbee_rust_future_complete_i32.restype = ctypes.c_int32
_UniffiLib.ffi_hyperbee_rust_future_poll_u64.argtypes = (
    ctypes.c_void_p,
    _UNIFFI_FUTURE_CONTINUATION_T,
    ctypes.c_size_t,
)
_UniffiLib.ffi_hyperbee_rust_future_poll_u64.restype = None
_UniffiLib.ffi_hyperbee_rust_future_cancel_u64.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_hyperbee_rust_future_cancel_u64.restype = None
_UniffiLib.ffi_hyperbee_rust_future_free_u64.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_hyperbee_rust_future_free_u64.restype = None
_UniffiLib.ffi_hyperbee_rust_future_complete_u64.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_hyperbee_rust_future_complete_u64.restype = ctypes.c_uint64
_UniffiLib.ffi_hyperbee_rust_future_poll_i64.argtypes = (
    ctypes.c_void_p,
    _UNIFFI_FUTURE_CONTINUATION_T,
    ctypes.c_size_t,
)
_UniffiLib.ffi_hyperbee_rust_future_poll_i64.restype = None
_UniffiLib.ffi_hyperbee_rust_future_cancel_i64.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_hyperbee_rust_future_cancel_i64.restype = None
_UniffiLib.ffi_hyperbee_rust_future_free_i64.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_hyperbee_rust_future_free_i64.restype = None
_UniffiLib.ffi_hyperbee_rust_future_complete_i64.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_hyperbee_rust_future_complete_i64.restype = ctypes.c_int64
_UniffiLib.ffi_hyperbee_rust_future_poll_f32.argtypes = (
    ctypes.c_void_p,
    _UNIFFI_FUTURE_CONTINUATION_T,
    ctypes.c_size_t,
)
_UniffiLib.ffi_hyperbee_rust_future_poll_f32.restype = None
_UniffiLib.ffi_hyperbee_rust_future_cancel_f32.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_hyperbee_rust_future_cancel_f32.restype = None
_UniffiLib.ffi_hyperbee_rust_future_free_f32.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_hyperbee_rust_future_free_f32.restype = None
_UniffiLib.ffi_hyperbee_rust_future_complete_f32.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_hyperbee_rust_future_complete_f32.restype = ctypes.c_float
_UniffiLib.ffi_hyperbee_rust_future_poll_f64.argtypes = (
    ctypes.c_void_p,
    _UNIFFI_FUTURE_CONTINUATION_T,
    ctypes.c_size_t,
)
_UniffiLib.ffi_hyperbee_rust_future_poll_f64.restype = None
_UniffiLib.ffi_hyperbee_rust_future_cancel_f64.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_hyperbee_rust_future_cancel_f64.restype = None
_UniffiLib.ffi_hyperbee_rust_future_free_f64.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_hyperbee_rust_future_free_f64.restype = None
_UniffiLib.ffi_hyperbee_rust_future_complete_f64.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_hyperbee_rust_future_complete_f64.restype = ctypes.c_double
_UniffiLib.ffi_hyperbee_rust_future_poll_pointer.argtypes = (
    ctypes.c_void_p,
    _UNIFFI_FUTURE_CONTINUATION_T,
    ctypes.c_size_t,
)
_UniffiLib.ffi_hyperbee_rust_future_poll_pointer.restype = None
_UniffiLib.ffi_hyperbee_rust_future_cancel_pointer.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_hyperbee_rust_future_cancel_pointer.restype = None
_UniffiLib.ffi_hyperbee_rust_future_free_pointer.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_hyperbee_rust_future_free_pointer.restype = None
_UniffiLib.ffi_hyperbee_rust_future_complete_pointer.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_hyperbee_rust_future_complete_pointer.restype = ctypes.c_void_p
_UniffiLib.ffi_hyperbee_rust_future_poll_rust_buffer.argtypes = (
    ctypes.c_void_p,
    _UNIFFI_FUTURE_CONTINUATION_T,
    ctypes.c_size_t,
)
_UniffiLib.ffi_hyperbee_rust_future_poll_rust_buffer.restype = None
_UniffiLib.ffi_hyperbee_rust_future_cancel_rust_buffer.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_hyperbee_rust_future_cancel_rust_buffer.restype = None
_UniffiLib.ffi_hyperbee_rust_future_free_rust_buffer.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_hyperbee_rust_future_free_rust_buffer.restype = None
_UniffiLib.ffi_hyperbee_rust_future_complete_rust_buffer.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_hyperbee_rust_future_complete_rust_buffer.restype = _UniffiRustBuffer
_UniffiLib.ffi_hyperbee_rust_future_poll_void.argtypes = (
    ctypes.c_void_p,
    _UNIFFI_FUTURE_CONTINUATION_T,
    ctypes.c_size_t,
)
_UniffiLib.ffi_hyperbee_rust_future_poll_void.restype = None
_UniffiLib.ffi_hyperbee_rust_future_cancel_void.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_hyperbee_rust_future_cancel_void.restype = None
_UniffiLib.ffi_hyperbee_rust_future_free_void.argtypes = (
    ctypes.c_void_p,
)
_UniffiLib.ffi_hyperbee_rust_future_free_void.restype = None
_UniffiLib.ffi_hyperbee_rust_future_complete_void.argtypes = (
    ctypes.c_void_p,
    ctypes.POINTER(_UniffiRustCallStatus),
)
_UniffiLib.ffi_hyperbee_rust_future_complete_void.restype = None
_UniffiLib.uniffi_hyperbee_checksum_func_default_sub_config.argtypes = (
)
_UniffiLib.uniffi_hyperbee_checksum_func_default_sub_config.restype = ctypes.c_uint16
_UniffiLib.uniffi_hyperbee_checksum_func_hyperbee_from_ram.argtypes = (
)
_UniffiLib.uniffi_hyperbee_checksum_func_hyperbee_from_ram.restype = ctypes.c_uint16
_UniffiLib.uniffi_hyperbee_checksum_func_hyperbee_from_storage_dir.argtypes = (
)
_UniffiLib.uniffi_hyperbee_checksum_func_hyperbee_from_storage_dir.restype = ctypes.c_uint16
_UniffiLib.uniffi_hyperbee_checksum_method_hyperbee_delete.argtypes = (
)
_UniffiLib.uniffi_hyperbee_checksum_method_hyperbee_delete.restype = ctypes.c_uint16
_UniffiLib.uniffi_hyperbee_checksum_method_hyperbee_get.argtypes = (
)
_UniffiLib.uniffi_hyperbee_checksum_method_hyperbee_get.restype = ctypes.c_uint16
_UniffiLib.uniffi_hyperbee_checksum_method_hyperbee_put.argtypes = (
)
_UniffiLib.uniffi_hyperbee_checksum_method_hyperbee_put.restype = ctypes.c_uint16
_UniffiLib.uniffi_hyperbee_checksum_method_hyperbee_sub.argtypes = (
)
_UniffiLib.uniffi_hyperbee_checksum_method_hyperbee_sub.restype = ctypes.c_uint16
_UniffiLib.uniffi_hyperbee_checksum_method_hyperbee_version.argtypes = (
)
_UniffiLib.uniffi_hyperbee_checksum_method_hyperbee_version.restype = ctypes.c_uint16
_UniffiLib.uniffi_hyperbee_checksum_method_prefixed_delete.argtypes = (
)
_UniffiLib.uniffi_hyperbee_checksum_method_prefixed_delete.restype = ctypes.c_uint16
_UniffiLib.uniffi_hyperbee_checksum_method_prefixed_get.argtypes = (
)
_UniffiLib.uniffi_hyperbee_checksum_method_prefixed_get.restype = ctypes.c_uint16
_UniffiLib.uniffi_hyperbee_checksum_method_prefixed_put.argtypes = (
)
_UniffiLib.uniffi_hyperbee_checksum_method_prefixed_put.restype = ctypes.c_uint16
_UniffiLib.ffi_hyperbee_uniffi_contract_version.argtypes = (
)
_UniffiLib.ffi_hyperbee_uniffi_contract_version.restype = ctypes.c_uint32
_uniffi_check_contract_api_version(_UniffiLib)
_uniffi_check_api_checksums(_UniffiLib)

# Async support# RustFuturePoll values
_UNIFFI_RUST_FUTURE_POLL_READY = 0
_UNIFFI_RUST_FUTURE_POLL_MAYBE_READY = 1

# Stores futures for _uniffi_continuation_callback
_UniffiContinuationPointerManager = _UniffiPointerManager()

# Continuation callback for async functions
# lift the return value or error and resolve the future, causing the async function to resume.
@_UNIFFI_FUTURE_CONTINUATION_T
def _uniffi_continuation_callback(future_ptr, poll_code):
    (eventloop, future) = _UniffiContinuationPointerManager.release_pointer(future_ptr)
    eventloop.call_soon_threadsafe(_uniffi_set_future_result, future, poll_code)

def _uniffi_set_future_result(future, poll_code):
    if not future.cancelled():
        future.set_result(poll_code)

async def _uniffi_rust_call_async(rust_future, ffi_poll, ffi_complete, ffi_free, lift_func, error_ffi_converter):
    try:
        eventloop = asyncio.get_running_loop()

        # Loop and poll until we see a _UNIFFI_RUST_FUTURE_POLL_READY value
        while True:
            future = eventloop.create_future()
            ffi_poll(
                rust_future,
                _uniffi_continuation_callback,
                _UniffiContinuationPointerManager.new_pointer((eventloop, future)),
            )
            poll_code = await future
            if poll_code == _UNIFFI_RUST_FUTURE_POLL_READY:
                break

        return lift_func(
            _rust_call_with_error(error_ffi_converter, ffi_complete, rust_future)
        )
    finally:
        ffi_free(rust_future)

# Public interface members begin here.


class _UniffiConverterUInt64(_UniffiConverterPrimitiveInt):
    CLASS_NAME = "u64"
    VALUE_MIN = 0
    VALUE_MAX = 2**64

    @staticmethod
    def read(buf):
        return buf.read_u64()

    @staticmethod
    def write(value, buf):
        buf.write_u64(value)

class _UniffiConverterString:
    @staticmethod
    def check_lower(value):
        if not isinstance(value, str):
            raise TypeError("argument must be str, not {}".format(type(value).__name__))
        return value

    @staticmethod
    def read(buf):
        size = buf.read_i32()
        if size < 0:
            raise InternalError("Unexpected negative string length")
        utf8_bytes = buf.read(size)
        return utf8_bytes.decode("utf-8")

    @staticmethod
    def write(value, buf):
        utf8_bytes = value.encode("utf-8")
        buf.write_i32(len(utf8_bytes))
        buf.write(utf8_bytes)

    @staticmethod
    def lift(buf):
        with buf.consume_with_stream() as stream:
            return stream.read(stream.remaining()).decode("utf-8")

    @staticmethod
    def lower(value):
        with _UniffiRustBuffer.alloc_with_builder() as builder:
            builder.write(value.encode("utf-8"))
            return builder.finalize()

class _UniffiConverterBytes(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        size = buf.read_i32()
        if size < 0:
            raise InternalError("Unexpected negative byte string length")
        return buf.read(size)

    @staticmethod
    def check_lower(value):
        try:
            memoryview(value)
        except TypeError:
            raise TypeError("a bytes-like object is required, not {!r}".format(type(value).__name__))

    @staticmethod
    def write(value, buf):
        buf.write_i32(len(value))
        buf.write(value)



class HyperbeeProtocol(typing.Protocol):
    """
    An append only B-Tree built on [`Hypercore`](hypercore::Hypercore). It provides a key-value
    store API, with methods for [inserting](Hyperbee::put), [getting](Hyperbee::get), and
    [deleting](Hyperbee::del) key-value pair. As well as creating [sorted
    iterators](Hyperbee::traverse), and ["sub" B-Trees](Hyperbee::sub) for grouping related data.
    """

    def delete(self, key: "bytes"):
        """
        Delete the given key from the tree.
        Returns the `seq` from the key if it was deleted.
        """

        raise NotImplementedError
    def get(self, key: "bytes"):
        """
        Get the value corresponding to the provided `key` from the Hyperbee
        """

        raise NotImplementedError
    def put(self, key: "bytes",value: "typing.Optional[bytes]"):
        """
        Insert the given key and value into the tree
        Returs the `seq` of the new key, and `Option<u64>` which contains the `seq` of the old key
        if it was replaced.
        """

        raise NotImplementedError
    def sub(self, prefix: "bytes",config: "PrefixedConfig"):
        """
        Create a new tree with all it's operation's prefixed by the provided `prefix`.
        Requires a config object to define the seperator between the prefix and the key.
        Create the config with [`default_sub_config`]. This provides gives a NULL bytes seperator,
        which is the same value as the Holepunch JavaScript library.
        """

        raise NotImplementedError
    def version(self, ):
        """
        The number of blocks in the hypercore.
        The first block is always the header block so:
        `version` would be the `seq` of the next block
        `version - 1` is most recent block
        """

        raise NotImplementedError

class Hyperbee:
    """
    An append only B-Tree built on [`Hypercore`](hypercore::Hypercore). It provides a key-value
    store API, with methods for [inserting](Hyperbee::put), [getting](Hyperbee::get), and
    [deleting](Hyperbee::del) key-value pair. As well as creating [sorted
    iterators](Hyperbee::traverse), and ["sub" B-Trees](Hyperbee::sub) for grouping related data.
    """


    _pointer: ctypes.c_void_p

    def __del__(self):
        # In case of partial initialization of instances.
        pointer = getattr(self, "_pointer", None)
        if pointer is not None:
            _rust_call(_UniffiLib.uniffi_hyperbee_fn_free_hyperbee, pointer)

    def _uniffi_clone_pointer(self):
        return _rust_call(_UniffiLib.uniffi_hyperbee_fn_clone_hyperbee, self._pointer)

    # Used by alternative constructors or any methods which return this type.
    @classmethod
    def _make_instance_(cls, pointer):
        # Lightly yucky way to bypass the usual __init__ logic
        # and just create a new instance with the required pointer.
        inst = cls.__new__(cls)
        inst._pointer = pointer
        return inst


    def delete(self, key: "bytes"):
        """
        Delete the given key from the tree.
        Returns the `seq` from the key if it was deleted.
        """

        _UniffiConverterBytes.check_lower(key)
        
        return _uniffi_rust_call_async(
            _UniffiLib.uniffi_hyperbee_fn_method_hyperbee_delete(
                self._uniffi_clone_pointer(), 
        _UniffiConverterBytes.lower(key)
            ),
            _UniffiLib.ffi_hyperbee_rust_future_poll_rust_buffer,
            _UniffiLib.ffi_hyperbee_rust_future_complete_rust_buffer,
            _UniffiLib.ffi_hyperbee_rust_future_free_rust_buffer,
            # lift function
            _UniffiConverterOptionalUInt64.lift,
            # Error FFI converter
            _UniffiConverterTypeHyperbeeError,
        )





    def get(self, key: "bytes"):
        """
        Get the value corresponding to the provided `key` from the Hyperbee
        """

        _UniffiConverterBytes.check_lower(key)
        
        return _uniffi_rust_call_async(
            _UniffiLib.uniffi_hyperbee_fn_method_hyperbee_get(
                self._uniffi_clone_pointer(), 
        _UniffiConverterBytes.lower(key)
            ),
            _UniffiLib.ffi_hyperbee_rust_future_poll_rust_buffer,
            _UniffiLib.ffi_hyperbee_rust_future_complete_rust_buffer,
            _UniffiLib.ffi_hyperbee_rust_future_free_rust_buffer,
            # lift function
            _UniffiConverterOptionalTypeGotten.lift,
            # Error FFI converter
            _UniffiConverterTypeHyperbeeError,
        )





    def put(self, key: "bytes",value: "typing.Optional[bytes]"):
        """
        Insert the given key and value into the tree
        Returs the `seq` of the new key, and `Option<u64>` which contains the `seq` of the old key
        if it was replaced.
        """

        _UniffiConverterBytes.check_lower(key)
        
        _UniffiConverterOptionalBytes.check_lower(value)
        
        return _uniffi_rust_call_async(
            _UniffiLib.uniffi_hyperbee_fn_method_hyperbee_put(
                self._uniffi_clone_pointer(), 
        _UniffiConverterBytes.lower(key),
        _UniffiConverterOptionalBytes.lower(value)
            ),
            _UniffiLib.ffi_hyperbee_rust_future_poll_rust_buffer,
            _UniffiLib.ffi_hyperbee_rust_future_complete_rust_buffer,
            _UniffiLib.ffi_hyperbee_rust_future_free_rust_buffer,
            # lift function
            _UniffiConverterTypePutten.lift,
            # Error FFI converter
            _UniffiConverterTypeHyperbeeError,
        )





    def sub(self, prefix: "bytes",config: "PrefixedConfig"):
        """
        Create a new tree with all it's operation's prefixed by the provided `prefix`.
        Requires a config object to define the seperator between the prefix and the key.
        Create the config with [`default_sub_config`]. This provides gives a NULL bytes seperator,
        which is the same value as the Holepunch JavaScript library.
        """

        _UniffiConverterBytes.check_lower(prefix)
        
        _UniffiConverterTypePrefixedConfig.check_lower(config)
        
        return _uniffi_rust_call_async(
            _UniffiLib.uniffi_hyperbee_fn_method_hyperbee_sub(
                self._uniffi_clone_pointer(), 
        _UniffiConverterBytes.lower(prefix),
        _UniffiConverterTypePrefixedConfig.lower(config)
            ),
            _UniffiLib.ffi_hyperbee_rust_future_poll_pointer,
            _UniffiLib.ffi_hyperbee_rust_future_complete_pointer,
            _UniffiLib.ffi_hyperbee_rust_future_free_pointer,
            # lift function
            _UniffiConverterTypePrefixed.lift,
            # Error FFI converter
            None,
        )





    def version(self, ):
        """
        The number of blocks in the hypercore.
        The first block is always the header block so:
        `version` would be the `seq` of the next block
        `version - 1` is most recent block
        """

        return _uniffi_rust_call_async(
            _UniffiLib.uniffi_hyperbee_fn_method_hyperbee_version(
                self._uniffi_clone_pointer(), 
            ),
            _UniffiLib.ffi_hyperbee_rust_future_poll_u64,
            _UniffiLib.ffi_hyperbee_rust_future_complete_u64,
            _UniffiLib.ffi_hyperbee_rust_future_free_u64,
            # lift function
            _UniffiConverterUInt64.lift,
            # Error FFI converter
            None,
        )




class _UniffiConverterTypeHyperbee:

    @staticmethod
    def lift(value: int):
        return Hyperbee._make_instance_(value)

    @staticmethod
    def check_lower(value: Hyperbee):
        if not isinstance(value, Hyperbee):
            raise TypeError("Expected Hyperbee instance, {} found".format(type(value).__name__))

    @staticmethod
    def lower(value: HyperbeeProtocol):
        if not isinstance(value, Hyperbee):
            raise TypeError("Expected Hyperbee instance, {} found".format(type(value).__name__))
        return value._uniffi_clone_pointer()

    @classmethod
    def read(cls, buf: _UniffiRustBuffer):
        ptr = buf.read_u64()
        if ptr == 0:
            raise InternalError("Raw pointer value was null")
        return cls.lift(ptr)

    @classmethod
    def write(cls, value: HyperbeeProtocol, buf: _UniffiRustBuffer):
        buf.write_u64(cls.lower(value))



class PrefixedProtocol(typing.Protocol):
    def delete(self, key: "bytes"):
        """
        Insert the provided key and it's value. Key is is Prefixed by this [`Prefixed`]'s instance's `prefix`
        """

        raise NotImplementedError
    def get(self, key: "bytes"):
        """
        Get the value associated with the provided key plus this [`Prefixed`]'s instance's `prefix`
        """

        raise NotImplementedError
    def put(self, key: "bytes",value: "typing.Optional[bytes]"):
        """
        Insert the value into the tree with the provided key plus this [`Prefixed`]'s instance's `prefix`
        """

        raise NotImplementedError

class Prefixed:

    _pointer: ctypes.c_void_p

    def __del__(self):
        # In case of partial initialization of instances.
        pointer = getattr(self, "_pointer", None)
        if pointer is not None:
            _rust_call(_UniffiLib.uniffi_hyperbee_fn_free_prefixed, pointer)

    def _uniffi_clone_pointer(self):
        return _rust_call(_UniffiLib.uniffi_hyperbee_fn_clone_prefixed, self._pointer)

    # Used by alternative constructors or any methods which return this type.
    @classmethod
    def _make_instance_(cls, pointer):
        # Lightly yucky way to bypass the usual __init__ logic
        # and just create a new instance with the required pointer.
        inst = cls.__new__(cls)
        inst._pointer = pointer
        return inst


    def delete(self, key: "bytes"):
        """
        Insert the provided key and it's value. Key is is Prefixed by this [`Prefixed`]'s instance's `prefix`
        """

        _UniffiConverterBytes.check_lower(key)
        
        return _uniffi_rust_call_async(
            _UniffiLib.uniffi_hyperbee_fn_method_prefixed_delete(
                self._uniffi_clone_pointer(), 
        _UniffiConverterBytes.lower(key)
            ),
            _UniffiLib.ffi_hyperbee_rust_future_poll_rust_buffer,
            _UniffiLib.ffi_hyperbee_rust_future_complete_rust_buffer,
            _UniffiLib.ffi_hyperbee_rust_future_free_rust_buffer,
            # lift function
            _UniffiConverterOptionalUInt64.lift,
            # Error FFI converter
            _UniffiConverterTypeHyperbeeError,
        )





    def get(self, key: "bytes"):
        """
        Get the value associated with the provided key plus this [`Prefixed`]'s instance's `prefix`
        """

        _UniffiConverterBytes.check_lower(key)
        
        return _uniffi_rust_call_async(
            _UniffiLib.uniffi_hyperbee_fn_method_prefixed_get(
                self._uniffi_clone_pointer(), 
        _UniffiConverterBytes.lower(key)
            ),
            _UniffiLib.ffi_hyperbee_rust_future_poll_rust_buffer,
            _UniffiLib.ffi_hyperbee_rust_future_complete_rust_buffer,
            _UniffiLib.ffi_hyperbee_rust_future_free_rust_buffer,
            # lift function
            _UniffiConverterOptionalTypeGotten.lift,
            # Error FFI converter
            _UniffiConverterTypeHyperbeeError,
        )





    def put(self, key: "bytes",value: "typing.Optional[bytes]"):
        """
        Insert the value into the tree with the provided key plus this [`Prefixed`]'s instance's `prefix`
        """

        _UniffiConverterBytes.check_lower(key)
        
        _UniffiConverterOptionalBytes.check_lower(value)
        
        return _uniffi_rust_call_async(
            _UniffiLib.uniffi_hyperbee_fn_method_prefixed_put(
                self._uniffi_clone_pointer(), 
        _UniffiConverterBytes.lower(key),
        _UniffiConverterOptionalBytes.lower(value)
            ),
            _UniffiLib.ffi_hyperbee_rust_future_poll_rust_buffer,
            _UniffiLib.ffi_hyperbee_rust_future_complete_rust_buffer,
            _UniffiLib.ffi_hyperbee_rust_future_free_rust_buffer,
            # lift function
            _UniffiConverterTypePutten.lift,
            # Error FFI converter
            _UniffiConverterTypeHyperbeeError,
        )




class _UniffiConverterTypePrefixed:

    @staticmethod
    def lift(value: int):
        return Prefixed._make_instance_(value)

    @staticmethod
    def check_lower(value: Prefixed):
        if not isinstance(value, Prefixed):
            raise TypeError("Expected Prefixed instance, {} found".format(type(value).__name__))

    @staticmethod
    def lower(value: PrefixedProtocol):
        if not isinstance(value, Prefixed):
            raise TypeError("Expected Prefixed instance, {} found".format(type(value).__name__))
        return value._uniffi_clone_pointer()

    @classmethod
    def read(cls, buf: _UniffiRustBuffer):
        ptr = buf.read_u64()
        if ptr == 0:
            raise InternalError("Raw pointer value was null")
        return cls.lift(ptr)

    @classmethod
    def write(cls, value: PrefixedProtocol, buf: _UniffiRustBuffer):
        buf.write_u64(cls.lower(value))


class Gotten:
    seq: "int"
    value: "typing.Optional[bytes]"
    @typing.no_type_check
    def __init__(self, seq: "int", value: "typing.Optional[bytes]"):
        self.seq = seq
        self.value = value

    def __str__(self):
        return "Gotten(seq={}, value={})".format(self.seq, self.value)

    def __eq__(self, other):
        if self.seq != other.seq:
            return False
        if self.value != other.value:
            return False
        return True

class _UniffiConverterTypeGotten(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        return Gotten(
            seq=_UniffiConverterUInt64.read(buf),
            value=_UniffiConverterOptionalBytes.read(buf),
        )

    @staticmethod
    def check_lower(value):
        _UniffiConverterUInt64.check_lower(value.seq)
        _UniffiConverterOptionalBytes.check_lower(value.value)

    @staticmethod
    def write(value, buf):
        _UniffiConverterUInt64.write(value.seq, buf)
        _UniffiConverterOptionalBytes.write(value.value, buf)


class KeyValueData:
    """
    Data related to a key value pair within the [`Hyperbee`].
    """

    seq: "int"
    """
    The index of the block within the [`Hypercore`](hypercore::Hypercore) where this data is stored.
    """

    key: "bytes"
    """
    The key. The data by which the [`Hyperbee`] is ordered.
    """

    value: "typing.Optional[bytes]"
    """
    The value.
    """

    @typing.no_type_check
    def __init__(self, seq: "int", key: "bytes", value: "typing.Optional[bytes]"):
        self.seq = seq
        self.key = key
        self.value = value

    def __str__(self):
        return "KeyValueData(seq={}, key={}, value={})".format(self.seq, self.key, self.value)

    def __eq__(self, other):
        if self.seq != other.seq:
            return False
        if self.key != other.key:
            return False
        if self.value != other.value:
            return False
        return True

class _UniffiConverterTypeKeyValueData(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        return KeyValueData(
            seq=_UniffiConverterUInt64.read(buf),
            key=_UniffiConverterBytes.read(buf),
            value=_UniffiConverterOptionalBytes.read(buf),
        )

    @staticmethod
    def check_lower(value):
        _UniffiConverterUInt64.check_lower(value.seq)
        _UniffiConverterBytes.check_lower(value.key)
        _UniffiConverterOptionalBytes.check_lower(value.value)

    @staticmethod
    def write(value, buf):
        _UniffiConverterUInt64.write(value.seq, buf)
        _UniffiConverterBytes.write(value.key, buf)
        _UniffiConverterOptionalBytes.write(value.value, buf)


class PrefixedConfig:
    seperator: "bytes"
    """
    The seperator between the prefix and the key. The default is the NULL byte `b"\0"` which is
    the same as the [JavaScript
    implementation](https://docs.pears.com/building-blocks/hyperbee#const-sub-db.sub-sub-prefix-options).
    """

    @typing.no_type_check
    def __init__(self, seperator: "bytes"):
        self.seperator = seperator

    def __str__(self):
        return "PrefixedConfig(seperator={})".format(self.seperator)

    def __eq__(self, other):
        if self.seperator != other.seperator:
            return False
        return True

class _UniffiConverterTypePrefixedConfig(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        return PrefixedConfig(
            seperator=_UniffiConverterBytes.read(buf),
        )

    @staticmethod
    def check_lower(value):
        _UniffiConverterBytes.check_lower(value.seperator)

    @staticmethod
    def write(value, buf):
        _UniffiConverterBytes.write(value.seperator, buf)


class Putten:
    old_seq: "typing.Optional[int]"
    new_seq: "int"
    @typing.no_type_check
    def __init__(self, old_seq: "typing.Optional[int]", new_seq: "int"):
        self.old_seq = old_seq
        self.new_seq = new_seq

    def __str__(self):
        return "Putten(old_seq={}, new_seq={})".format(self.old_seq, self.new_seq)

    def __eq__(self, other):
        if self.old_seq != other.old_seq:
            return False
        if self.new_seq != other.new_seq:
            return False
        return True

class _UniffiConverterTypePutten(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        return Putten(
            old_seq=_UniffiConverterOptionalUInt64.read(buf),
            new_seq=_UniffiConverterUInt64.read(buf),
        )

    @staticmethod
    def check_lower(value):
        _UniffiConverterOptionalUInt64.check_lower(value.old_seq)
        _UniffiConverterUInt64.check_lower(value.new_seq)

    @staticmethod
    def write(value, buf):
        _UniffiConverterOptionalUInt64.write(value.old_seq, buf)
        _UniffiConverterUInt64.write(value.new_seq, buf)


# HyperbeeError
# We want to define each variant as a nested class that's also a subclass,
# which is tricky in Python.  To accomplish this we're going to create each
# class separately, then manually add the child classes to the base class's
# __dict__.  All of this happens in dummy class to avoid polluting the module
# namespace.
class HyperbeeError(Exception):
    """
    Error type used by all [`Result`]s in this library.
    """

    pass

_UniffiTempHyperbeeError = HyperbeeError

class HyperbeeError:  # type: ignore
    class HypercoreError(_UniffiTempHyperbeeError):

        def __repr__(self):
            return "HyperbeeError.HypercoreError({})".format(repr(str(self)))
    _UniffiTempHyperbeeError.HypercoreError = HypercoreError # type: ignore
    class DecodeError(_UniffiTempHyperbeeError):

        def __repr__(self):
            return "HyperbeeError.DecodeError({})".format(repr(str(self)))
    _UniffiTempHyperbeeError.DecodeError = DecodeError # type: ignore
    class NoBlockAtSeqError(_UniffiTempHyperbeeError):

        def __repr__(self):
            return "HyperbeeError.NoBlockAtSeqError({})".format(repr(str(self)))
    _UniffiTempHyperbeeError.NoBlockAtSeqError = NoBlockAtSeqError # type: ignore
    class TreeBuilderError(_UniffiTempHyperbeeError):

        def __repr__(self):
            return "HyperbeeError.TreeBuilderError({})".format(repr(str(self)))
    _UniffiTempHyperbeeError.TreeBuilderError = TreeBuilderError # type: ignore
    class BlocksBuilderError(_UniffiTempHyperbeeError):

        def __repr__(self):
            return "HyperbeeError.BlocksBuilderError({})".format(repr(str(self)))
    _UniffiTempHyperbeeError.BlocksBuilderError = BlocksBuilderError # type: ignore
    class HyperbeeBuilderError(_UniffiTempHyperbeeError):

        def __repr__(self):
            return "HyperbeeError.HyperbeeBuilderError({})".format(repr(str(self)))
    _UniffiTempHyperbeeError.HyperbeeBuilderError = HyperbeeBuilderError # type: ignore
    class U64ToUsizeConversionError(_UniffiTempHyperbeeError):

        def __repr__(self):
            return "HyperbeeError.U64ToUsizeConversionError({})".format(repr(str(self)))
    _UniffiTempHyperbeeError.U64ToUsizeConversionError = U64ToUsizeConversionError # type: ignore
    class GetChildInTraverseError(_UniffiTempHyperbeeError):

        def __repr__(self):
            return "HyperbeeError.GetChildInTraverseError({})".format(repr(str(self)))
    _UniffiTempHyperbeeError.GetChildInTraverseError = GetChildInTraverseError # type: ignore
    class TraverseConfigBuilderError(_UniffiTempHyperbeeError):

        def __repr__(self):
            return "HyperbeeError.TraverseConfigBuilderError({})".format(repr(str(self)))
    _UniffiTempHyperbeeError.TraverseConfigBuilderError = TraverseConfigBuilderError # type: ignore
    class BuildIteratorInTraverseError(_UniffiTempHyperbeeError):

        def __repr__(self):
            return "HyperbeeError.BuildIteratorInTraverseError({})".format(repr(str(self)))
    _UniffiTempHyperbeeError.BuildIteratorInTraverseError = BuildIteratorInTraverseError # type: ignore
    class YoloIndexEncodingError(_UniffiTempHyperbeeError):

        def __repr__(self):
            return "HyperbeeError.YoloIndexEncodingError({})".format(repr(str(self)))
    _UniffiTempHyperbeeError.YoloIndexEncodingError = YoloIndexEncodingError # type: ignore
    class HeaderEncodingError(_UniffiTempHyperbeeError):

        def __repr__(self):
            return "HyperbeeError.HeaderEncodingError({})".format(repr(str(self)))
    _UniffiTempHyperbeeError.HeaderEncodingError = HeaderEncodingError # type: ignore
    class NodeEncodingError(_UniffiTempHyperbeeError):

        def __repr__(self):
            return "HyperbeeError.NodeEncodingError({})".format(repr(str(self)))
    _UniffiTempHyperbeeError.NodeEncodingError = NodeEncodingError # type: ignore
    class KeyFromUtf8Error(_UniffiTempHyperbeeError):

        def __repr__(self):
            return "HyperbeeError.KeyFromUtf8Error({})".format(repr(str(self)))
    _UniffiTempHyperbeeError.KeyFromUtf8Error = KeyFromUtf8Error # type: ignore
    class NoRootError(_UniffiTempHyperbeeError):

        def __repr__(self):
            return "HyperbeeError.NoRootError({})".format(repr(str(self)))
    _UniffiTempHyperbeeError.NoRootError = NoRootError # type: ignore
    class HeaderAlreadyExists(_UniffiTempHyperbeeError):

        def __repr__(self):
            return "HyperbeeError.HeaderAlreadyExists({})".format(repr(str(self)))
    _UniffiTempHyperbeeError.HeaderAlreadyExists = HeaderAlreadyExists # type: ignore
    class TestError(_UniffiTempHyperbeeError):

        def __repr__(self):
            return "HyperbeeError.TestError({})".format(repr(str(self)))
    _UniffiTempHyperbeeError.TestError = TestError # type: ignore

HyperbeeError = _UniffiTempHyperbeeError # type: ignore
del _UniffiTempHyperbeeError


class _UniffiConverterTypeHyperbeeError(_UniffiConverterRustBuffer):
    @staticmethod
    def read(buf):
        variant = buf.read_i32()
        if variant == 1:
            return HyperbeeError.HypercoreError(
                _UniffiConverterString.read(buf),
            )
        if variant == 2:
            return HyperbeeError.DecodeError(
                _UniffiConverterString.read(buf),
            )
        if variant == 3:
            return HyperbeeError.NoBlockAtSeqError(
                _UniffiConverterString.read(buf),
            )
        if variant == 4:
            return HyperbeeError.TreeBuilderError(
                _UniffiConverterString.read(buf),
            )
        if variant == 5:
            return HyperbeeError.BlocksBuilderError(
                _UniffiConverterString.read(buf),
            )
        if variant == 6:
            return HyperbeeError.HyperbeeBuilderError(
                _UniffiConverterString.read(buf),
            )
        if variant == 7:
            return HyperbeeError.U64ToUsizeConversionError(
                _UniffiConverterString.read(buf),
            )
        if variant == 8:
            return HyperbeeError.GetChildInTraverseError(
                _UniffiConverterString.read(buf),
            )
        if variant == 9:
            return HyperbeeError.TraverseConfigBuilderError(
                _UniffiConverterString.read(buf),
            )
        if variant == 10:
            return HyperbeeError.BuildIteratorInTraverseError(
                _UniffiConverterString.read(buf),
            )
        if variant == 11:
            return HyperbeeError.YoloIndexEncodingError(
                _UniffiConverterString.read(buf),
            )
        if variant == 12:
            return HyperbeeError.HeaderEncodingError(
                _UniffiConverterString.read(buf),
            )
        if variant == 13:
            return HyperbeeError.NodeEncodingError(
                _UniffiConverterString.read(buf),
            )
        if variant == 14:
            return HyperbeeError.KeyFromUtf8Error(
                _UniffiConverterString.read(buf),
            )
        if variant == 15:
            return HyperbeeError.NoRootError(
                _UniffiConverterString.read(buf),
            )
        if variant == 16:
            return HyperbeeError.HeaderAlreadyExists(
                _UniffiConverterString.read(buf),
            )
        if variant == 17:
            return HyperbeeError.TestError(
                _UniffiConverterString.read(buf),
            )
        raise InternalError("Raw enum value doesn't match any cases")

    @staticmethod
    def check_lower(value):
        if isinstance(value, HyperbeeError.HypercoreError):
            return
        if isinstance(value, HyperbeeError.DecodeError):
            return
        if isinstance(value, HyperbeeError.NoBlockAtSeqError):
            return
        if isinstance(value, HyperbeeError.TreeBuilderError):
            return
        if isinstance(value, HyperbeeError.BlocksBuilderError):
            return
        if isinstance(value, HyperbeeError.HyperbeeBuilderError):
            return
        if isinstance(value, HyperbeeError.U64ToUsizeConversionError):
            return
        if isinstance(value, HyperbeeError.GetChildInTraverseError):
            return
        if isinstance(value, HyperbeeError.TraverseConfigBuilderError):
            return
        if isinstance(value, HyperbeeError.BuildIteratorInTraverseError):
            return
        if isinstance(value, HyperbeeError.YoloIndexEncodingError):
            return
        if isinstance(value, HyperbeeError.HeaderEncodingError):
            return
        if isinstance(value, HyperbeeError.NodeEncodingError):
            return
        if isinstance(value, HyperbeeError.KeyFromUtf8Error):
            return
        if isinstance(value, HyperbeeError.NoRootError):
            return
        if isinstance(value, HyperbeeError.HeaderAlreadyExists):
            return
        if isinstance(value, HyperbeeError.TestError):
            return

    @staticmethod
    def write(value, buf):
        if isinstance(value, HyperbeeError.HypercoreError):
            buf.write_i32(1)
        if isinstance(value, HyperbeeError.DecodeError):
            buf.write_i32(2)
        if isinstance(value, HyperbeeError.NoBlockAtSeqError):
            buf.write_i32(3)
        if isinstance(value, HyperbeeError.TreeBuilderError):
            buf.write_i32(4)
        if isinstance(value, HyperbeeError.BlocksBuilderError):
            buf.write_i32(5)
        if isinstance(value, HyperbeeError.HyperbeeBuilderError):
            buf.write_i32(6)
        if isinstance(value, HyperbeeError.U64ToUsizeConversionError):
            buf.write_i32(7)
        if isinstance(value, HyperbeeError.GetChildInTraverseError):
            buf.write_i32(8)
        if isinstance(value, HyperbeeError.TraverseConfigBuilderError):
            buf.write_i32(9)
        if isinstance(value, HyperbeeError.BuildIteratorInTraverseError):
            buf.write_i32(10)
        if isinstance(value, HyperbeeError.YoloIndexEncodingError):
            buf.write_i32(11)
        if isinstance(value, HyperbeeError.HeaderEncodingError):
            buf.write_i32(12)
        if isinstance(value, HyperbeeError.NodeEncodingError):
            buf.write_i32(13)
        if isinstance(value, HyperbeeError.KeyFromUtf8Error):
            buf.write_i32(14)
        if isinstance(value, HyperbeeError.NoRootError):
            buf.write_i32(15)
        if isinstance(value, HyperbeeError.HeaderAlreadyExists):
            buf.write_i32(16)
        if isinstance(value, HyperbeeError.TestError):
            buf.write_i32(17)



class _UniffiConverterOptionalUInt64(_UniffiConverterRustBuffer):
    @classmethod
    def check_lower(cls, value):
        if value is not None:
            _UniffiConverterUInt64.check_lower(value)

    @classmethod
    def write(cls, value, buf):
        if value is None:
            buf.write_u8(0)
            return

        buf.write_u8(1)
        _UniffiConverterUInt64.write(value, buf)

    @classmethod
    def read(cls, buf):
        flag = buf.read_u8()
        if flag == 0:
            return None
        elif flag == 1:
            return _UniffiConverterUInt64.read(buf)
        else:
            raise InternalError("Unexpected flag byte for optional type")



class _UniffiConverterOptionalBytes(_UniffiConverterRustBuffer):
    @classmethod
    def check_lower(cls, value):
        if value is not None:
            _UniffiConverterBytes.check_lower(value)

    @classmethod
    def write(cls, value, buf):
        if value is None:
            buf.write_u8(0)
            return

        buf.write_u8(1)
        _UniffiConverterBytes.write(value, buf)

    @classmethod
    def read(cls, buf):
        flag = buf.read_u8()
        if flag == 0:
            return None
        elif flag == 1:
            return _UniffiConverterBytes.read(buf)
        else:
            raise InternalError("Unexpected flag byte for optional type")



class _UniffiConverterOptionalTypeGotten(_UniffiConverterRustBuffer):
    @classmethod
    def check_lower(cls, value):
        if value is not None:
            _UniffiConverterTypeGotten.check_lower(value)

    @classmethod
    def write(cls, value, buf):
        if value is None:
            buf.write_u8(0)
            return

        buf.write_u8(1)
        _UniffiConverterTypeGotten.write(value, buf)

    @classmethod
    def read(cls, buf):
        flag = buf.read_u8()
        if flag == 0:
            return None
        elif flag == 1:
            return _UniffiConverterTypeGotten.read(buf)
        else:
            raise InternalError("Unexpected flag byte for optional type")

def default_sub_config() -> "PrefixedConfig":
    """
    Create the default config for creating a [`Prefixed`] instance
    """

    return _UniffiConverterTypePrefixedConfig.lift(_rust_call(_UniffiLib.uniffi_hyperbee_fn_func_default_sub_config,))


def hyperbee_from_ram():
    """
    Helper for creating a Hyperbee that exists in RAM.
    """

    return _uniffi_rust_call_async(
        _UniffiLib.uniffi_hyperbee_fn_func_hyperbee_from_ram(),
        _UniffiLib.ffi_hyperbee_rust_future_poll_pointer,
        _UniffiLib.ffi_hyperbee_rust_future_complete_pointer,
        _UniffiLib.ffi_hyperbee_rust_future_free_pointer,
        # lift function
        _UniffiConverterTypeHyperbee.lift,
        # Error FFI converter
        _UniffiConverterTypeHyperbeeError,
    )

def hyperbee_from_storage_dir(path_to_storage_dir: "str"):
    """
    Helper for creating a Hyperbee from the provided path to a storage directory
    """

    _UniffiConverterString.check_lower(path_to_storage_dir)
    
    return _uniffi_rust_call_async(
        _UniffiLib.uniffi_hyperbee_fn_func_hyperbee_from_storage_dir(
        _UniffiConverterString.lower(path_to_storage_dir)),
        _UniffiLib.ffi_hyperbee_rust_future_poll_pointer,
        _UniffiLib.ffi_hyperbee_rust_future_complete_pointer,
        _UniffiLib.ffi_hyperbee_rust_future_free_pointer,
        # lift function
        _UniffiConverterTypeHyperbee.lift,
        # Error FFI converter
        _UniffiConverterTypeHyperbeeError,
    )

__all__ = [
    "InternalError",
    "HyperbeeError",
    "Gotten",
    "KeyValueData",
    "PrefixedConfig",
    "Putten",
    "default_sub_config",
    "hyperbee_from_ram",
    "hyperbee_from_storage_dir",
    "Hyperbee",
    "Prefixed",
]

